/****** Object:  Table [dbo].[tabDokumente]    Script Date: 04.10.2019 16:47:46 ******/
SET ANSI_NULLS ON

SET QUOTED_IDENTIFIER ON

CREATE TABLE [dbo].[tabDokumente](
	[DocID] [nvarchar](20) NOT NULL,
	[Art] [int] NULL,
	[ZugehoerigerKey] [nvarchar](50) NULL,
	[Bereich] [nvarchar](250) NULL,
	[Register] [int] NULL,
	[Sortierung] [nvarchar](50) NULL,
	[Besonderheit] [nvarchar](3) NULL,
	[DokNameOriginal] [nvarchar](255) NULL,
	[DokNameIntern] [nvarchar](255) NULL,
	[EUser] [int] NULL,
	[EDatum] [datetime] NULL,
	[AUser] [int] NULL,
	[ADatum] [datetime] NULL,
	[PruefungsID]  AS (left([ZugehoerigerKey],(12))) PERSISTED,
	[TS] [timestamp] NULL,
	[Element] [nvarchar](50) NULL,
	[ZipFile] [nvarchar](250) NULL,
	[DokumentVersion] [int] NULL,
	[EngagementID] [nvarchar](17) NULL,
	[DatumLetzteAenderung] [datetime] NULL,
	[MutterDokument] [nvarchar](255) NULL,
	[UploadDurch] [int] NULL,
	[UploadAm] [datetime] NULL,
 CONSTRAINT [PK_tabDokumentePP] PRIMARY KEY CLUSTERED 
(
	[DocID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]


GO



/****** Object:  Table [dbo].[tabDokumenteAusgecheckt]    Script Date: 04.10.2019 15:48:44 ******/
SET ANSI_NULLS ON

SET QUOTED_IDENTIFIER ON

CREATE TABLE [dbo].[tabDokumenteAusgecheckt](
	[ZipFile] [nvarchar](250) NOT NULL,
	[AusgechecktDurch] [int] NOT NULL,
	[AusgechecktZeit] [datetime] NULL,
	[StandDokument] [datetime] NULL,
	[PruefungsID] [nvarchar](12) NULL,
 CONSTRAINT [PK_tabDokumenteAusgecheckt_1] PRIMARY KEY CLUSTERED 
(
	[ZipFile] ASC,
	[AusgechecktDurch] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

ALTER TABLE [dbo].[tabDokumenteAusgecheckt] ADD  CONSTRAINT [DF_tabDokumenteAusgecheckt_AusgechecktZeit]  DEFAULT (getdate()) FOR [AusgechecktZeit]
GO


Create PROCEDURE [dbo].[spDokumentAlsNeueVersionEinfuegen]
@AlteDocID nvarchar(24),
@NeueDocID nvarchar(24),
@DokNameOriginalNeu nvarchar(255),
@DokNameInternNeu nvarchar(255),
@EUser int,
@ZipFileNeu nvarchar(250),
@DatumLetzteAenderungNeu datetime,
@DokumentVersionNeu int,
@MutterDokument nvarchar(255),
@UploadDurch int

AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
INSERT INTO tabDokumente
             (DocID, Art, ZugehoerigerKey, Bereich, Register, Sortierung, Besonderheit, DokNameOriginal, DokNameIntern, 
			 EUser, EDatum, Element, ZipFile, DokumentVersion, EngagementID, MutterDokument, DatumLetzteAenderung, UploadDurch, UploadAm)
SELECT        @NeueDocID AS NeueDocID, Art, ZugehoerigerKey, Bereich, Register, Sortierung, Besonderheit, @DokNameOriginalNeu AS DokNameOriginalNeu, @DokNameInternNeu AS DokNameInternNeu, 
              EUser, getdate(), Element, @ZipFileNeu AS ZipFileNeu, @DokumentVersionNeu AS DokumentVersionNeu, EngagementID, @MutterDokument as MutterDokument, 
			  @DatumLetzteAenderungNeu AS DatumLetzteAenderungNeu, @UploadDurch, getdate()
FROM            tabDokumente AS D
WHERE        (DocID = @AlteDocID)

END


GO

/****** Object:  StoredProcedure [dbo].[spDokumentAuschecken]    Script Date: 04.10.2019 16:52:22 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

create PROCEDURE [dbo].[spDokumentAuschecken]
@ZipFile nvarchar(250),
@AusgechecktDurch int,
@StandDokument datetime,
@PruefungsID nvarchar(12)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here

Delete from [tabDokumenteAusgecheckt] where ZipFile = @ZipFile and AusgechecktDurch = @AusgechecktDurch;

    -- Insert statements for procedure here
BEGIN TRY
INSERT INTO tabDokumenteAusgecheckt (ZipFile, AusgechecktDurch, StandDokument, PruefungsID) VALUES (@ZipFile, @AusgechecktDurch, @StandDokument, @PruefungsID)
END TRY
BEGIN CATCH
END CATCH
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumentBeimKeyVorhanden]    Script Date: 04.10.2019 16:53:48 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create PROCEDURE [dbo].[spDokumentBeimKeyVorhanden]
@ZugehoerigerKey nvarchar(21),
@Art int,
@DokNameOriginal nvarchar(250),
@Element nvarchar(50)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT        DocID
FROM            tabDokumente
WHERE        (ZugehoerigerKey = @ZugehoerigerKey) and Art = @art and (DokNameOriginal = @DokNameOriginal) AND (Element = @Element Or @Element = '')
order by Sortierung

END
go

/****** Object:  StoredProcedure [dbo].[spDokumente]    Script Date: 04.10.2019 16:55:01 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

/****** Object:  UserDefinedFunction [dbo].[IstEigenesPrueffeld]    Script Date: 04.10.2019 16:58:50 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[IstEigenerPruefungsFall]
(
	-- Add the parameters for the function here
	@EngagementID nvarchar(17),
	@SPBenutzer nvarchar(50)
)
RETURNS int
AS
BEGIN
Return
(
SELECT         count(EngagementID) AS Antwort
FROM            stabPersonen INNER JOIN
                         tabRollenverteilung ON stabPersonen.SPID = tabRollenverteilung.PPID INNER JOIN
                         tabPruefungsfall ON tabRollenverteilung.PTID = tabPruefungsfall.PTID
WHERE        (stabPersonen.SPBenutzer = @Spbenutzer) AND (tabPruefungsfall.EngagementID = @EngagementID)
)
END
GO

/****** Object:  UserDefinedFunction [dbo].[getHoechsteDokVersion]    Script Date: 04.10.2019 17:27:49 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION [dbo].[getHoechsteDokVersion]
(
	-- Add the parameters for the function here
	@PruefungsID nvarchar(12),
	@MutterDokument nvarchar(255)
)
RETURNS int
AS
BEGIN
Return
(
SELECT Max(DokumentVersion) 
FROM tabdokumente 
where PruefungsID = @PruefungsID and MutterDokument = @MutterDokument 
GROUP BY PruefungsID, Mutterdokument
)
END
GO


/****** Object:  UserDefinedFunction [dbo].[IstEigenesPrueffeld]    Script Date: 04.10.2019 16:58:50 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spDokumente]
@PruefungsID nvarchar(12),
@Register nvarchar(50),
@Suchfilter nvarchar(400), 
@Benutzer nvarchar(50),
@OrderbyClause nvarchar(100)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT        DocID, ZugehoerigerKey, isnull(Bereich,'Bereich nicht eingetragen') as Bereich, DokNameOriginal, DokNameIntern, 
case when Doknameoriginal = doknameintern then DokNameOriginal else DokNameOriginal + ' (' + isnull(DokNameIntern,'Interner Name fehlt') + ')' end as Dokname,
 EUser, EDatum, AUser, ADatum, ZipFile, PruefungsID , Besonderheit, Art, DokumentVersion, MutterDokument, DatumLetzteAenderung, isnull(EngagementID,'') as EngagementID,
 dbo.isteigenerPruefungsFall(EngagementID, @Benutzer) as IstEigenerPruefungsfall
FROM            tabDokumente
WHERE        (Pruefungsid = @PruefungsID) and Register = @register
and DokumentVersion =  dbo.gethoechsteDokVersion(PruefungsID,MutterDokument)
and (@Suchfilter is null OR DokNameIntern Like @Suchfilter or DokNameOriginal like @Suchfilter)
ORDER BY
		  CASE WHEN @OrderbyClause = 'Bereich asc' THEN Sortierung  END ASC,
		  CASE WHEN @OrderbyClause = 'Bereich asc' THEN DokNameOriginal  END ASC,
		  CASE WHEN @OrderbyClause = 'Bereich desc' THEN Sortierung END DESC,
		  CASE WHEN @OrderbyClause = 'DokNameOriginal asc' THEN DokNameOriginal END ASC,
		  CASE WHEN @OrderbyClause = 'DokNameOriginal desc' THEN DokNameOriginal END DESC,
		  CASE WHEN @OrderbyClause = 'Besonderheit asc' THEN Besonderheit END ASC,
		  CASE WHEN @OrderbyClause = 'Besonderheit asc' THEN Sortierung END ASC,
		  CASE WHEN @OrderbyClause = 'Besonderheit asc' THEN DokNameOriginal END ASC,
		  CASE WHEN @OrderbyClause = 'Besonderheit desc' THEN Besonderheit END DESC,
		  CASE WHEN @OrderbyClause = 'Besonderheit desc' THEN Sortierung END ASC,
		  CASE WHEN @OrderbyClause = 'Besonderheit desc' THEN DokNameOriginal END ASC

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteAusgechecktLoeschenProBenutzer]    Script Date: 04.10.2019 17:29:51 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


CREATE PROCEDURE [dbo].[spDokumenteAusgechecktLoeschenProBenutzer]
@AusgechecktDurch int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
Delete from tabDokumenteAusgecheckt
WHERE        (AusgechecktDurch = @AusgechecktDurch) 

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteAusgechecktLoeschenProFile]    Script Date: 04.10.2019 17:30:28 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spDokumenteAusgechecktLoeschenProFile]
@ZipFile nvarchar(250),
@AusgechecktDurch int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
Delete from tabDokumenteAusgecheckt
WHERE        (AusgechecktDurch = @AusgechecktDurch) AND (ZipFile = @ZipFile)

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteAusgechecktLoeschenProPruefungUndBenutzer]    Script Date: 04.10.2019 17:32:26 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spDokumenteAusgechecktLoeschenProPruefungUndBenutzer]
@PruefungsID nvarchar(12),
@AusgechecktDurch int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
Delete from tabDokumenteAusgecheckt
WHERE        (AusgechecktDurch = @AusgechecktDurch) AND (PruefungsID = @PruefungsID)

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteDa]    Script Date: 04.10.2019 17:33:07 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
create PROCEDURE [dbo].[spDokumenteDa]
@ZugehoerigerKey nvarchar(21),
@Art int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT        top 1 DocID
FROM            tabDokumente
WHERE        (ZugehoerigerKey = @ZugehoerigerKey) and Art = @art

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteGetDocID]    Script Date: 04.10.2019 17:34:08 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE [dbo].[spDokumenteGetDocID]
@Art int,
@PruefungsID nvarchar(12)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
Select Max(DocID) as HKey from tabDokumente where Art = @Art and PruefungsID = @PruefungsID
END
GO

/****** Object:  UserDefinedFunction [dbo].[getDokumentVersion]    Script Date: 04.10.2019 17:38:42 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE Function [dbo].[getDokumentVersion]
(
@ZipFile nvarchar(250)
)
RETURNS int
AS
BEGIN
Return
(

Select distinct Dokumentversion from tabDokumente where Zipfile = @Zipfile
						 )
END
GO

/****** Object:  UserDefinedFunction [dbo].[getMutterdokument]    Script Date: 04.10.2019 17:39:22 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

create Function [dbo].[getMutterdokument]
(
@ZipFile nvarchar(250)
)
RETURNS nvarchar(255)
AS
BEGIN
Return
(
Select distinct MutterDokument from tabDokumente where Zipfile = @Zipfile
					 )
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteHoehereVersionVorhanden]    Script Date: 04.10.2019 17:34:58 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spDokumenteHoehereVersionVorhanden]
@ZipFile nvarchar(250),
@PruefungsID nvarchar(12)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
Declare @HoechsteVersion int
declare @MutterDokument nvarchar(255)
set @MutterDokument = dbo.GetMutterdokument(@ZipFile)
set @HoechsteVersion = dbo.getHoechsteDokVersion(@PruefungsID,@MutterDokument)


 Select 
  Case When dbo.getDokumentVersion(@ZipFile) = @HoechsteVersion then 
        '' 
	else
		  D.Docid 
	end as DocID
	FROM   tabDokumente AS D LEFT OUTER JOIN stabPersonen AS P ON D.UploadDurch = P.SPID
							 where D.MutterDokument = @MutterDokument and D.PruefungsID = @PruefungsID and D.DokumentVersion = @HoechsteVersion	


END
GO

/****** Object:  StoredProcedure [dbo].[spDokumentEinfuegen]    Script Date: 04.10.2019 17:40:42 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spDokumentEinfuegen]
@DocID nvarchar(24),
@Art int,
@Register int,
@ZugehoerigerKey nvarchar(21),
@Bereich nvarchar(250),
@Sortierung nvarchar(50),
@DokNameOriginal nvarchar(255),
@DokNameIntern nvarchar(255),
@EUser int,
@Besonderheit nvarchar(3),
@Element nvarchar(50),
@ZipFile nvarchar(250),
@EngagementID nvarchar(17),
@DatumLetzteAenderung datetime,
@DokumentVersion int,
@MutterDokument nvarchar(255),
@UploadDurch int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
INSERT INTO [dbo].[tabDokumente]
           ([DocID]
		   ,[Art]
		   ,[Register]
		   ,[Sortierung]
           ,[ZugehoerigerKey]
           ,[Bereich]
           ,[DokNameOriginal]
           ,[DokNameIntern]
           ,[EUser]
           ,[EDatum]
		   ,[Besonderheit]
		   ,[Element]
		   ,[ZipFile]
		   ,[EngagementID]
		   ,[DatumLetzteAenderung]
		   ,[DokumentVersion]
		   ,[MutterDokument]
		   ,[UploadDurch]
		   ,[UploadAm])
     VALUES
	 (@DocID, @Art, @Register,  @Sortierung, @ZugehoerigerKey, @Bereich, @DokNameOriginal, @DokNameIntern, @euser, 
	   getdate(), @Besonderheit, @Element, @ZipFile, @EngagementID, @DatumLetzteAenderung, @DokumentVersion, @MutterDokument, @UploadDurch, Getdate())

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteVergleicheAuscheckStand]    Script Date: 04.10.2019 17:42:29 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spDokumenteVergleicheAuscheckStand]
@ZipFile nvarchar(250),
@AusgechecktDurch int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT        TOP (1) D.ZipFile, DA.AusgechecktDurch, DA.AusgechecktZeit, DA.StandDokument, D.DatumLetzteAenderung, D.UploadAm, D.UploadDurch, 
isnull(P.SPName,'Unbekannt') as SPNAMe, isnull(P.SPVorname,'Unbekannt') as SPVorname
FROM            tabDokumente AS D INNER JOIN
                         tabDokumenteAusgecheckt AS DA ON D.ZipFile = DA.ZipFile Left JOIN
                         stabPersonen as P ON D.UploadDurch = P.SPID
WHERE        (DA.AusgechecktDurch = @AusgechecktDurch) AND (D.ZipFile = @ZipFile)

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteZuordnungenVorhanden]    Script Date: 04.10.2019 17:46:51 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE [dbo].[spDokumenteZuordnungenVorhanden]
@DoknameOriginal nvarchar(255),
@PruefungsID nvarchar(12)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT        count(DocID) as Anzahl
FROM            tabDokumente
WHERE        (DokNameOriginal = @DoknameOriginal) and PruefungsID = @PruefungsID

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumentUpdateUploadInfo]    Script Date: 04.10.2019 17:47:42 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spDokumentUpdateUploadInfo]
@DatumLetzteAenderung Datetime,
@UploadDurch int,
@UploadAm Datetime,
@ZipFile nvarchar(250) 
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
Update tabDokumente set DatumLetzteAenderung = @DatumLetzteAenderung, UploadDurch = @UploadDurch, UploadAm = @UploadAm where Zipfile = @ZipFile
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumentVersionen]    Script Date: 04.10.2019 17:48:17 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[spDokumentVersionen]
@PruefungsID nvarchar(12),
@Mutterdokument nvarchar(255)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT    distinct  DokNameOriginal, DokNameIntern, 
case when Doknameoriginal = doknameintern then DokNameOriginal else DokNameOriginal + ' (' + isnull(DokNameIntern,'Interner Name fehlt') + ')' end as Dokname,
  ZipFile, PruefungsID , DokumentVersion, MutterDokument
FROM            tabDokumente
WHERE        (Pruefungsid = @PruefungsID) and MutterDokument = @Mutterdokument

Order by DokumentVersion

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumentVersionsInfo]    Script Date: 04.10.2019 17:49:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spDokumentVersionsInfo]
@DocID nvarchar(255)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT       DatumLetzteAenderung, DokumentVersion, UploadAm, P.SPName, P.SPVorname 
FROM            tabDokumente AS D left join stabPersonen as P on D.UploadDurch = P.SPID
WHERE        (DocID = @DocID)

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteReadZipFile]    Script Date: 04.10.2019 17:50:00 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spDokumenteReadZipFile]
@DoknameOriginal nvarchar(255),
@PruefungsID nvarchar(12)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT       top 1 Zipfile, DatumLetzteAenderung, DokumentVersion, MutterDokument, Art 
FROM            tabDokumente
WHERE        (DokNameOriginal = @DoknameOriginal) and PruefungsID = @PruefungsID 

END
GO

Alter TAble stabKundenparameter ADD Verwendung nvarchar(50) NULL;
GO

Alter TAble stabKundenparameter ADD Thema nvarchar(255) NULL;
GO

ALTER TABLE tabPruefung ADD VorPruefungsID nvarchar(12) NULL;
GO

/****** Object:  UserDefinedFunction [dbo].[getPruefung]    Script Date: 08.10.2019 15:07:27 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create FUNCTION [dbo].[getPruefung]
(
	-- Add the parameters for the function here
	@PruefungsID int
)
RETURNS nvarchar(500)
AS
BEGIN
Return
(
SELECT        S.SPKName + ' - ' + P.Pruefungsname + ' '  + right(cast(P.PJahr as nvarchar(4)),2) AS Pruefung
FROM            tabPruefung AS P INNER JOIN
                         stabSparkassen AS S ON P.Sparkasse = S.SSID 
WHERE        (P.PruefungsID = @PruefungsID)
)
END
GO

/****** Object:  Table [dbo].[stabPW7]    Script Date: 09.10.2019 11:53:45 ******/
SET ANSI_NULLS ON

SET QUOTED_IDENTIFIER ON

CREATE TABLE [dbo].[stabPW7](
	[PWID] [int] NOT NULL,
	[PW7] [nvarchar](50) NULL,
	[ValidFrom] [datetime] NULL,
	[ValidTo] [datetime] NULL,
	[CreateDate] [datetime] NULL,
	[CreateUser] [int] NULL,
	[ChangeDate] [datetime] NULL,
	[ChangeUser] [int] NULL,
	[TS] [timestamp] NULL,
 CONSTRAINT [PK_PW7] PRIMARY KEY CLUSTERED 
(
	[PWID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

ALTER TABLE [dbo].[stabPW7] ADD  CONSTRAINT [DF_stabPW7_CreateDate]  DEFAULT (getdate()) FOR [CreateDate]


GO

/****** Object:  StoredProcedure [dbo].[spPW7]    Script Date: 09.10.2019 11:53:15 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create PROCEDURE [dbo].[spPW7]
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT        stabPW7.PWID, stabPW7.PW7, stabPW7.ValidFrom, stabPW7.ValidTo, stabPW7.CreateDate, isnull(SPName,'') + ', ' + isnull(SPVorname,'') as Ersteller
            
FROM            stabPW7 INNER JOIN
                         stabPersonen ON stabPW7.CreateUser = stabPersonen.SPID

END
GO

/****** Object:  StoredProcedure [dbo].[spPW7Add]    Script Date: 09.10.2019 11:58:18 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create PROCEDURE [dbo].[spPW7Add]
   @PWID int,
   @PW7 nvarchar(50),
   @ValidFrom datetime,
   @ValidTo datetime,
   @CreateUser int
 
AS
BEGIN
  SET NOCOUNT ON
Update dbo.stabPW7 set ValidTo = dateadd(d,-1,@validfrom) where  PWID = (Select MAX(PWID) from dbo.stabPW7  )

INSERT INTO [dbo].[stabPW7]
           ([PWID]
		   ,[PW7]
           ,[CreateUser]
           ,[ValidFrom]
           ,[ValidTo])
     VALUES
           (@PWID, @PW7, @CreateUser, @ValidFrom, @ValidTo)
END
GO

/****** Object:  StoredProcedure [dbo].[spPW7Delete]    Script Date: 09.10.2019 12:00:12 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

create PROCEDURE [dbo].[spPW7Delete]
   @PWID int
AS
BEGIN
  SET NOCOUNT ON
Delete from dbo.stabPW7 where PWID = @PWID;
Update dbo.stabPW7 set ValidTo = '31.12.2099' where PWID = (Select MAX(PWID) from stabPW7 )
END
GO

/****** Object:  StoredProcedure [dbo].[spPW7Lesen]    Script Date: 09.10.2019 12:00:47 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create PROCEDURE [dbo].[spPW7Lesen]
   @Filedate Date
AS
BEGIN
  SET NOCOUNT ON
SELECT PW7 from stabPW7 where 
validfrom <= @Filedate and (validto >= @Filedate or validto is null)
END
GO

/****** Object:  StoredProcedure [dbo].[spPW7Loeschbar]    Script Date: 09.10.2019 12:01:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[spPW7Loeschbar]
 AS
BEGIN
  SET NOCOUNT ON
Select validfrom from stabPW7 where PWID = (Select MAX(PWID) from stabPW7 )
END
GO

/****** Object:  StoredProcedure [dbo].[spPW7Aenderbar]    Script Date: 09.10.2019 12:01:48 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[spPW7Aenderbar]
 AS
BEGIN
  SET NOCOUNT ON
Select case when validfrom >= DATEADD(d,2,getdate()) then 1 else 0 end
 from stabPW7 where PWID = (Select MAX(PWID) from stabPW7 )
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteGetDocID]    Script Date: 16.10.2019 16:08:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
Alter PROCEDURE [dbo].[spDokumenteGetDocID]
@Art int,
@PruefungsID int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
Select Max(DocID) as HKey from tabDokumente where Art = @Art and PruefungsID = @PruefungsID
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumente1DEP01BereichundSortierung]    Script Date: 16.10.2019 16:16:41 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

create PROCEDURE [dbo].[spDokumente1BereichundSortierung]
@ZugehoerigerKey nvarchar(21)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT     'Prfung allgemein' as Bereich,
            '001Prfungallgemein' AS Sortierung,
		     '' as Besonderheit						                            
FROM            tabPruefung
WHERE        (PruefungsID = @ZugehoerigerKey)
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteGetDocID]    Script Date: 16.10.2019 16:39:26 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
ALTER PROCEDURE [dbo].[spDokumenteGetDocID]
@Art int,
@PruefungsID nvarchar(12)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
Select Max(DocID) as HKey from tabDokumente where Art = @Art and PruefungsID = @PruefungsID
END
GO

/****** Object:  UserDefinedFunction [dbo].[IstEigenesPrueffeld]    Script Date: 17.10.2019 16:28:18 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

Create FUNCTION [dbo].[IstEigeneEngagementID]
(
	-- Add the parameters for the function here
	@EngagementID nvarchar(17),
	@SPBenutzer nvarchar(50)
)
RETURNS int
AS
BEGIN
Return
(
SELECT         count(EngagementID) AS Antwort
FROM            stabPersonen INNER JOIN
                         tabRollenverteilung ON stabPersonen.SPID = tabRollenverteilung.PPID INNER JOIN
                         tabPruefungsfall ON tabRollenverteilung.PTID = tabPruefungsfall.PTID
WHERE        (stabPersonen.SPBenutzer = @Spbenutzer) AND (tabPruefungsfall.EngagementID = @EngagementID)
)
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteProObjekt]    Script Date: 17.10.2019 16:25:17 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spDokumenteProObjekt]
@ZugehoerigerKey nvarchar(21),
@Art int,
@Benutzer nvarchar(50),
@Element nvarchar(50)

AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT        DocID, ZugehoerigerKey, Bereich, DokNameOriginal, DokNameIntern, PruefungsID, Besonderheit, ZipFile, Art ,  DokumentVersion, 
MutterDokument, DatumLetzteAenderung, isnull(EngagementID,'') as _EngagementID, 
 dbo.IstEigeneEngagementID(EngagementID, @Benutzer) as IstEigeneEngagementID
FROM            tabDokumente as D
WHERE        (ZugehoerigerKey = @ZugehoerigerKey) and Art = @art and (@Element is null OR Element = @Element) 
and DokumentVersion =  dbo.gethoechsteDokVersion(PruefungsID,MutterDokument)
order by Sortierung

END
GO

/****** Object:  UserDefinedFunction [dbo].[getPruefung]    Script Date: 17.10.2019 16:51:32 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER FUNCTION [dbo].[getPruefung]
(
	-- Add the parameters for the function here
	@PruefungsID nvarchar(12)
)
RETURNS nvarchar(500)
AS
BEGIN
Return
(
SELECT        S.SPKName + ' - ' + P.Pruefungsname + ' '  + right(cast(P.PJahr as nvarchar(4)),2) AS Pruefung
FROM            tabPruefung AS P INNER JOIN
                         stabSparkassen AS S ON P.Sparkasse = S.SSID 
WHERE        (P.PruefungsID = @PruefungsID)
)
END
GO

/****** Object:  UserDefinedFunction [dbo].[getPruefung]    Script Date: 17.10.2019 16:52:29 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER FUNCTION [dbo].[getPruefung]
(
	-- Add the parameters for the function here
	@PruefungsID nvarchar(12)
)
RETURNS nvarchar(500)
AS
BEGIN
Return
(
SELECT        P.Sparkasse + ' - ' + P.Pruefungsname + ' '  + right(cast(P.PJahr as nvarchar(4)),4) AS Pruefung
FROM            tabPruefung AS P INNER JOIN
                         stabSparkassen AS S ON P.INR = S.InstNr 
WHERE        (P.PruefungsID = @PruefungsID)
)
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumente1BereichundSortierung]    Script Date: 18.10.2019 09:43:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spDokumente2BereichundSortierung]
@ZugehoerigerKey nvarchar(21)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT     HauptKNENAMe as Bereich,
            '002' + HauptKNENAMe AS Sortierung,
		     '' as Besonderheit						                            
FROM            tabpruefungsfall
WHERE        (EngagementID = @ZugehoerigerKey)
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumente1BereichundSortierung]    Script Date: 18.10.2019 09:43:55 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spDokumente3BereichundSortierung]
@ZugehoerigerKey nvarchar(21)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT     KNNAMe as Bereich,
            '003' + KNNAMe AS Sortierung,
		     '' as Besonderheit						                            
FROM            tabPruefungkn
WHERE        (PKNID = @ZugehoerigerKey)
END
GO
/****** Object:  StoredProcedure [dbo].[spDokumentEinfuegen]    Script Date: 18.10.2019 11:46:19 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [dbo].[spDokumentEinfuegen]
@DocID nvarchar(24),
@Art int,
@Register int,
@ZugehoerigerKey nvarchar(50),
@Bereich nvarchar(250),
@Sortierung nvarchar(50),
@DokNameOriginal nvarchar(255),
@DokNameIntern nvarchar(255),
@EUser int,
@Besonderheit nvarchar(3),
@Element nvarchar(50),
@ZipFile nvarchar(250),
@EngagementID nvarchar(17),
@DatumLetzteAenderung datetime,
@DokumentVersion int,
@MutterDokument nvarchar(255),
@UploadDurch int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
INSERT INTO [dbo].[tabDokumente]
           ([DocID]
		   ,[Art]
		   ,[Register]
		   ,[Sortierung]
           ,[ZugehoerigerKey]
           ,[Bereich]
           ,[DokNameOriginal]
           ,[DokNameIntern]
           ,[EUser]
           ,[EDatum]
		   ,[Besonderheit]
		   ,[Element]
		   ,[ZipFile]
		   ,[EngagementID]
		   ,[DatumLetzteAenderung]
		   ,[DokumentVersion]
		   ,[MutterDokument]
		   ,[UploadDurch]
		   ,[UploadAm])
     VALUES
	 (@DocID, @Art, @Register,  @Sortierung, @ZugehoerigerKey, @Bereich, @DokNameOriginal, @DokNameIntern, @euser, 
	   getdate(), @Besonderheit, @Element, @ZipFile, @EngagementID, @DatumLetzteAenderung, @DokumentVersion, @MutterDokument, @UploadDurch, Getdate())

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteDa]    Script Date: 18.10.2019 11:47:02 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
ALTER PROCEDURE [dbo].[spDokumenteDa]
@ZugehoerigerKey nvarchar(50),
@Art int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT        top 1 DocID
FROM            tabDokumente
WHERE        (ZugehoerigerKey = @ZugehoerigerKey) and Art = @art

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumente1BereichundSortierung]    Script Date: 18.10.2019 11:48:06 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [dbo].[spDokumente1BereichundSortierung]
@ZugehoerigerKey nvarchar(50)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT     'Prfung allgemein' as Bereich,
            '001Prfungallgemein' AS Sortierung,
		     '' as Besonderheit						                            
FROM            tabPruefung
WHERE        (PruefungsID = @ZugehoerigerKey)
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumentBeimKeyVorhanden]    Script Date: 18.10.2019 12:13:39 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER PROCEDURE [dbo].[spDokumentBeimKeyVorhanden]
@ZugehoerigerKey nvarchar(50),
@Art int,
@DokNameOriginal nvarchar(250),
@Element nvarchar(50)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT        DocID
FROM            tabDokumente
WHERE        (ZugehoerigerKey = @ZugehoerigerKey) and Art = @art and (DokNameOriginal = @DokNameOriginal) AND (Element = @Element Or @Element = '')
order by Sortierung

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumente3BereichundSortierung]    Script Date: 18.10.2019 12:14:22 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [dbo].[spDokumente3BereichundSortierung]
@ZugehoerigerKey nvarchar(50)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT     KNNAMe as Bereich,
            '003' + KNNAMe AS Sortierung,
		     '' as Besonderheit						                            
FROM            tabPruefungkn
WHERE        (PKNID = @ZugehoerigerKey)
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumente2BereichundSortierung]    Script Date: 18.10.2019 12:14:52 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [dbo].[spDokumente2BereichundSortierung]
@ZugehoerigerKey nvarchar(50)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT     HauptKNENAMe as Bereich,
            '002' + HauptKNENAMe AS Sortierung,
		     '' as Besonderheit						                            
FROM            tabpruefungsfall
WHERE        (EngagementID = @ZugehoerigerKey)
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumenteProObjekt]    Script Date: 18.10.2019 12:25:33 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [dbo].[spDokumenteProObjekt]
@ZugehoerigerKey nvarchar(50),
@Art int,
@Benutzer nvarchar(50),
@Element nvarchar(50)

AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT        DocID, ZugehoerigerKey, Bereich, DokNameOriginal, DokNameIntern, PruefungsID, Besonderheit, ZipFile, Art ,  DokumentVersion, 
MutterDokument, DatumLetzteAenderung, isnull(EngagementID,'') as _EngagementID, 
 dbo.IstEigeneEngagementID(EngagementID, @Benutzer) as IstEigeneEngagementID
FROM            tabDokumente as D
WHERE        (ZugehoerigerKey = @ZugehoerigerKey) and Art = @art and (@Element is null OR Element = @Element) 
and DokumentVersion =  dbo.gethoechsteDokVersion(PruefungsID,MutterDokument)
order by Sortierung

END
GO

/****** Object:  StoredProcedure [dbo].[spDokumente2BereichundSortierung]    Script Date: 18.10.2019 12:14:52 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

Create PROCEDURE [dbo].[spDokumente4BereichundSortierung]
@ZugehoerigerKey nvarchar(50)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT        tabPruefungsfall.HauptKNEName + ' FSNr. ' + cast(tabFeststellungen.FSNR as nvarchar(3)) AS Bereich, '004' + tabPruefungsfall.HauptKNEName + cast(tabFeststellungen.FSNR as nvarchar(3)) AS Sortierung, '' AS Besonderheit
FROM            tabPruefungsfall INNER JOIN
                         tabFeststellungen ON tabPruefungsfall.EngagementID = tabFeststellungen.EngagementID
WHERE        (FSID = @ZugehoerigerKey)
END
GO

/****** Object:  UserDefinedFunction [dbo].[getnvarchar3]    Script Date: 21.10.2019 12:02:44 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date, ,>
-- Description:	<Description, ,>
-- =============================================
create FUNCTION [dbo].[getnvarchar3]
(
	-- Add the parameters for the function here
	@ID int
)
RETURNS nvarchar(9)
AS
BEGIN
Return
(
right('000' + cast(@ID as nvarchar(3)),3)
)
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumente2BereichundSortierung]    Script Date: 18.10.2019 12:14:52 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

alter PROCEDURE [dbo].[spDokumente4BereichundSortierung]
@ZugehoerigerKey nvarchar(50)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT        tabPruefungsfall.HauptKNEName + ' FSNr. ' + cast(tabFeststellungen.FSNR as nvarchar(3)) AS Bereich, 
'004' + tabPruefungsfall.HauptKNEName + dbo.getnvarchar3(tabfeststellungen.FSNR) AS Sortierung, '' AS Besonderheit
FROM            tabPruefungsfall INNER JOIN
                         tabFeststellungen ON tabPruefungsfall.EngagementID = tabFeststellungen.EngagementID
WHERE        (FSID = @ZugehoerigerKey)
END
GO

/****** Object:  StoredProcedure [dbo].[spDokumente]    Script Date: 21.10.2019 15:50:45 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
ALTER PROCEDURE [dbo].[spDokumente]
@PruefungsID nvarchar(12),
@Art int,
@Suchfilter nvarchar(400), 
@Benutzer nvarchar(50),
@OrderbyClause nvarchar(100)
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

    -- Insert statements for procedure here
SELECT        DocID, ZugehoerigerKey, isnull(Bereich,'Bereich nicht eingetragen') as Bereich, DokNameOriginal, DokNameIntern, 
case when Doknameoriginal = doknameintern then DokNameOriginal else DokNameOriginal + ' (' + isnull(DokNameIntern,'Interner Name fehlt') + ')' end as Dokname,
 EUser, EDatum, AUser, ADatum, ZipFile, PruefungsID , Besonderheit, Art, DokumentVersion, MutterDokument, DatumLetzteAenderung, isnull(EngagementID,'') as EngagementID,
 dbo.isteigenerPruefungsFall(EngagementID, @Benutzer) as IstEigenerPruefungsfall
FROM            tabDokumente
WHERE        (Pruefungsid = @PruefungsID) and Art = @Art
and DokumentVersion =  dbo.gethoechsteDokVersion(PruefungsID,MutterDokument)
and (@Suchfilter is null OR DokNameIntern Like @Suchfilter or DokNameOriginal like @Suchfilter)
ORDER BY
		  CASE WHEN @OrderbyClause = 'Bereich asc' THEN Sortierung  END ASC,
		  CASE WHEN @OrderbyClause = 'Bereich asc' THEN DokNameOriginal  END ASC,
		  CASE WHEN @OrderbyClause = 'Bereich desc' THEN Sortierung END DESC,
		  CASE WHEN @OrderbyClause = 'DokNameOriginal asc' THEN DokNameOriginal END ASC,
		  CASE WHEN @OrderbyClause = 'DokNameOriginal desc' THEN DokNameOriginal END DESC,
		  CASE WHEN @OrderbyClause = 'Besonderheit asc' THEN Besonderheit END ASC,
		  CASE WHEN @OrderbyClause = 'Besonderheit asc' THEN Sortierung END ASC,
		  CASE WHEN @OrderbyClause = 'Besonderheit asc' THEN DokNameOriginal END ASC,
		  CASE WHEN @OrderbyClause = 'Besonderheit desc' THEN Besonderheit END DESC,
		  CASE WHEN @OrderbyClause = 'Besonderheit desc' THEN Sortierung END ASC,
		  CASE WHEN @OrderbyClause = 'Besonderheit desc' THEN DokNameOriginal END ASC

END
GO


Update _tabversion set DBVersion = '5.91', DBDate = '21.10.2019'
GO