/****** Object:  StoredProcedure [dbo].[spPruefungskopf]    Script Date: 09.02.2021 16:27:59 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

ALTER PROCEDURE [dbo].[spPruefungskopf] 
    @PruefungsID nvarchar(12) 
AS
BEGIN
SET NOCOUNT ON;
SELECT
    CASE WHEN Left(S.SSID,1)='9' THEN 'F' 
	     WHEN Right(S.SSID,2)='00' THEN 'S' 
         ELSE 'T' 
    END AS WASKZ, 
   'KRE' AS SPAKZ, P.PruefungsID, P.Sparkasse AS SSName, P.PJahr, 
    P.Pruefungsname AS SPABezeichnung, 
     CASE WHEN Right(QSSINR,2)='00' THEN 'Sparkasse' ELSE '' END AS was, 
    S.KZ AS SSKZ, dbo.getanzahlpf(P.PruefungsID) AS AnzahlPF, 
    CASE WHEN Left(S.SSID,1)='9' THEN 'F' 
	     WHEN Right(S.SSID,2)='00' THEN 'S' 
         ELSE 'T' 
    END + isnull(S.KZ,'') + right(P.PJahr,2) + isnull(P.PruefungsKennzeichen,'KRE') +
    CASE WHEN Right(S.SSID,2) <> '00' THEN '_' +  Right(S.SSID,2) ELSE '' END
    AS SNPBeginn  
FROM (tabPruefung AS P INNER JOIN stabSparkassen AS S ON P.INR = S.InstNr)
WHERE P.PruefungsID = @PruefungsID;
END
GO

/****** Object:  StoredProcedure [dbo].[spBonitaetsstrukturSVB]    Script Date: 25.02.2021 11:21:40 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Detering-Hauger>
-- Create date: <20.10.2008>
-- alter============================================
CREATE PROCEDURE [dbo].spBemerkenswerteKrediteRSGV 
	@PruefungsID nvarchar(12) 
AS
BEGIN
SET NOCOUNT ON;
-- Insert statements for procedure here
SELECT P.EngagementID, p.HauptKNEOrt, p.Branche, p.Gewichtete_Bonitaet, 
       (P.PFLimit - P.KorrekturMFELimit) as LimitKorrigiert, 
       (P.PFInAn - P.KorrekturMFEInAn) as InAnKorrigiert, 
	   P.SuSiInAn - P.KorrekturMFESicherheitenInAn as SicherheitenInAn,
	   P.SuSiLimit - P.KorrekturMFESicherheitenLimit as SicherheitenLimit,
	   (P.PFBlankoLimit - P.KorrekturMFEBlankoLimit) as BlankoLimitKorrigiert, 
       (P.PFBlankoInAn - P.KorrekturMFEBlankoInan) as BlankoInAnKorrigiert,    
        P.ewb_v as Risikovorsorge
FROM  tabPruefungsfall AS P LEFT OUTER JOIN
      tabRisikogruppe AS R ON P.Risikogruppe = R.RID 
WHERE (P.PruefungsID = @PruefungsID) AND P.Pstatus <4 AND (R.RisikoUG =  2 OR R.RisikoUG = 3)
END
GO

/****** Object:  UserDefinedFunction [dbo].[getHoechsteDokVersion]    Script Date: 25.02.2021 12:05:49 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION [dbo].[getRatingnoteGroessterKN]
(
	-- Add the parameters for the function here
	@EngagementID nvarchar(17)
)
RETURNS int
AS
BEGIN
Return
(
SELECT Ratingnote 
FROM tabPruefungKN as KN 
where EngagementID = @EngagementID AND KNID = (Select TOP 1 KNID from tabPruefungkn where EngagementID = @EngagementID order by GKV desc)
)
END
GO

/****** Object:  StoredProcedure [dbo].[spBonitaetsstrukturSVB]    Script Date: 25.02.2021 11:21:40 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Detering-Hauger>
-- Create date: <20.10.2008>
-- alter============================================
Alter PROCEDURE [dbo].spBemerkenswerteKrediteRSGV 
	@PruefungsID nvarchar(12) 
AS
BEGIN
SET NOCOUNT ON;
-- Insert statements for procedure here
SELECT P.Engagementid, p.HauptKNEName + ' - Gruppe,' + char(10) + 'a) ' +  P.KNENummer + ' (Verbundfhrer), ' + p.HauptKNEOrt as Verbundfuehrer,
       p.Branche, p.Gewichtete_Bonitaet, dbo.getRatingnoteGroessterKN(P.Engagementid) as RatingKN,
       (P.PFLimit - P.KorrekturMFELimit) as LimitKorrigiert, 
       (P.PFInAn - P.KorrekturMFEInAn) as InAnKorrigiert, 
	   P.SuSiInAn - P.KorrekturMFESicherheitenInAn as SicherheitenInAnKorrigiert,
	   P.SuSiLimit - P.KorrekturMFESicherheitenLimit as SicherheitenLimitKorrigiert,
	   (P.PFBlankoLimit - P.KorrekturMFEBlankoLimit) as BlankoLimitKorrigiert, 
       (P.PFBlankoInAn - P.KorrekturMFEBlankoInan) as BlankoInAnKorrigiert,    
        P.ewb_v as Risikovorsorge, P.PFFazit, P.HauptKNEID
FROM  tabPruefungsfall AS P LEFT OUTER JOIN
      tabRisikogruppe AS R ON P.Risikogruppe = R.RID 
WHERE (P.PruefungsID = @PruefungsID) AND P.Pstatus <4 AND (R.RisikoUG =  2 OR R.RisikoUG = 3)
END
GO

/****** Object:  StoredProcedure [dbo].[spBemerkenswerteKrediteRSGV]    Script Date: 27.02.2021 18:22:18 ******/
/****** Holt die restlichen KN ausser dem Verbundfhrer fr den Bericht  ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Detering-Hauger>
-- Create date: <20.10.2008>
-- alter============================================
CREATE PROCEDURE [dbo].[spBemerkenswerteKrediteRSGV_KN] 
	@EngagementIDID nvarchar(17),
	@HauptKNEID nvarchar(27)
AS
BEGIN
SET NOCOUNT ON;
-- Insert statements for procedure here
SELECT kn.KNNummer + ', ' + KNOrt as KNNummerMitOrt
FROM  tabPruefungKN AS KN where EngagementID = @EngagementIDID and KNID <> @HauptKNEID
and Berichtsdarstellung = 1
END
GO




Update _tabVersion set DBVersion = '6.04', DBDate = '28.02.2021'
GO